<template>
  <div class="album">
    <a v-if="$route.query.hasOwnProperty('from')"
       :href="$route.query.from" class="back-button">&lt; zurück</a>
    <router-link v-else
                 :to="{ name: 'albums' }" tag="a" class="back-button">&lt; zurück</router-link>
    <br><br>

    <h3 class="album__title">
        {{title}} - {{date}}
    </h3>

    <!--
    Flickr Album: <a :href="flickr.url" target="_blank">{{flickr.url}}</a>
    <br><br>
    -->

    <CoolLightBox
        :items="lightbox.items"
        :index="lightbox.idx"
        :fullScreen="true"
        @close="closeLightbox"
        @on-change="openLightbox"
    />

    <a
       v-for="(image, idx) in images" :key="image.id"
       class="album__link"
       @click.prevent="openLightbox(idx)"
       :data-idx="idx"
       :href="image.url">
        <img class="album__img"
             :alt="image.title"
             :src="image.thumbUrl">
    </a>

    <p class="album__credits" v-html="credits"></p>

  </div>
</template>

<script>
import CoolLightBox from 'vue-cool-lightbox';

export default {
  components: {
    CoolLightBox,
  },

  data() {
    return {
      id: this.$route.params.id,
      date: this.$store.state.lastAlbum.date,
      title: this.$store.state.lastAlbum.title,
      images: this.$store.state.lastAlbum.images,
      credits: this.$store.state.lastAlbum.credits,
      flickr: this.$store.state.lastAlbum.flickr,

      query: this.$route.query,

      lightbox: {
        items: [],
        idx: null,
      },
    };
  },

  mounted() {
    this.init();
  },

  methods: {
    init() {
      if (Number(this.id) !== Number(this.$store.state.lastAlbum.id)) {
        this.images = [];
        this.$mediaApi.call('getAlbum', {id: this.id}, (res) => {
          this.date = res.date;
          this.title = res.title;
          this.images = res.images;
          this.credits = res.credits;
          this.flickr = res.flickr;
          this.lightbox.items = this.images.map((image) => {
            return {
              src: image.url,
              alt: image.title,
              title: image.title,
            };
          });
          this.$store.commit('setLastAlbum', res);

          if (this.$route.params.img) {
            this.lightbox.idx = this.$route.params.img-1;
          }
        });
      }
    },

    openLightbox(idx) {
      this.lightbox.idx = idx;
      this.$router.push({ name: 'album-img', params: { img: idx+1 } });
    },

    closeLightbox() {
      this.lightbox.idx = null;
      this.$router.push({ name: 'album', query: this.query });
    },
  },
};
</script>

<style lang="scss">
.album {
  line-height: 1em !important;

  .back-button {
    text-decoration: none;
    color: inherit;
    cursor: pointer;
  }

  &__link {
    display: inline-block;
    margin-right: 3px !important;
    margin-bottom: 1px !important;
    padding: 0;
  }

  &__img {
    width: 125px;
    height: 125px;
    transition: opacity 0.3s;

    &:hover {
      opacity: 0.8;
    }
  }
}
</style>
